
#ifndef DIRTREE_H
#define DIRTREE_H

/****************************************************************

    Copyright (c) 1996-1997 Fred Pesch

    This program is free software; you can redistribute it 
    and/or modify it under the terms of the GNU General 
    Public License as published by the Free Software 
    Foundation (version 2 of the License).

    This program is distributed in the hope that it will 
    be useful, but WITHOUT ANY WARRANTY; without even the 
    implied warranty of MERCHANTABILITY or FITNESS FOR A 
    PARTICULAR PURPOSE.  See the GNU General Public License 
    for more details.

    For a copy of the GNU General Public License, write to the 
    Free Software Foundation, Inc., 675 Mass Ave, Cambridge, 
    MA 02139, USA.

****************************************************************/

#include <Xm/Xm.h>
#include "dirlist.h"
#include "filelist.h"
#include "fileview.h"

/*---------------------------------- TYPEDEFS -------------------------------*/

typedef struct {
  WidgetList w_icon;
  int nb_icons;
  int nb_icons_managed;
} TDirIconList;

struct DirIconNode {
  TDirNode *dir;
  int icon_index;

  struct DirIconNode *parent;
  
  int nb_children;
  struct DirIconNode **child_icon;
};

typedef struct DirIconNode TDirIconNode;

/*--------------------------------- GLOBALS ---------------------------------*/

extern TDirIconList DirIconList;

extern TDirNode *RootDir;
extern TDirIconNode *RootIcon;

extern TDirNode *ActualDir;
extern TDirIconNode *ActualIcon;

extern TFileNode *ActualFileNodeList;
extern TViewNode *ActualFileViewList;

/*-------------------------------- FUNCTIONS --------------------------------*/

extern void GetLargestCellSize(TViewNode *filelist, int *width, int *height);

extern TDirIconNode *CreateRootIcon(TDirNode *dir);
extern int MakeDirIconOneLevel(TDirIconNode *actualnode);
extern void DeleteSubdirIconNode(TDirIconNode *parent);
extern void DeleteRootDirIcon(TDirIconNode *node);
extern void InstallDirTreeCB(void);
extern void CreateDirTree(char *cwd_string);
extern void HomeDirRoutine(void);
extern void RefreshTreeRoutine(void);
extern void GoToDirRefreshRoutine(char *destdir);
extern void GoToDirNewWindow(char *dir);

extern void RefreshFileList(void);

extern void InitModuleDirTree(void);

#endif















